
#----------------------------------------------------------------------------------------------------------------
# Dewesoft automation example for Python
#----------------------------------------------------------------------------------------------------------------
# Author: Dewesoft
# Notes:
#   - tested with Python 3.4
#----------------------------------------------------------------------------------------------------------------

from win32com.client import Dispatch
import sys


# create DCOM object
dw = Dispatch("Dewesoft.App")


# open Dewesoft
print("Initializing Dewesoft... ", end = "\n")
sys.stdout.flush()
dw.Init()
dw.Enabled = 1
dw.Visible = 1
print('Initialization done.')

# set window dimensions
dw.Top = 0
dw.Left = 0
dw.Width = 1024
dw.Height = 768

# change PATH to Setup file accordingly
dw.LoadSetup(r"C:\Users\Dewesoft\Documents\DCOM-Python\LiveData_test\test.dxs")

# build channel list
dw.Data.BuildChannelList()

# number of all channels
print("\nNumber of all channels: %d" % dw.Data.AllChannels.Count)

# number of used channels
print("Number of used channels: %d" % dw.Data.UsedChannels.Count)

# creating list of all channels
conn_list = [dw.Data.UsedChannels.Item(i) for i in range(dw.Data.UsedChannels.Count)]


# list of used channels
print("Properties of used channels:")
for i in range(0, dw.Data.UsedChannels.Count):
    strChannel = (f"Channel name: {dw.Data.UsedChannels.Item(i).Name}, "
                  f"DataType: {dw.Data.UsedChannels.Item(i).DataType}, "
                  f"Unit: {dw.Data.UsedChannels.Item(i).Unit_}, "
                  f"Scale: {dw.Data.UsedChannels.Item(i).Scale}, "
                  f"Offset: {dw.Data.UsedChannels.Item(i).Offset}")
    print(strChannel)
print("\n")


print("Starting measure mode...")
dw.Start()
try:
    while True:
        for conn in conn_list:
            if conn.DBDataSize >=1:
                BufPos = conn.DBPos
                PosToRead = conn.DBPos - 1
                if BufPos == 0:
                    PosToRead = PosToRead + conn.DBDataSize
                current_val = conn.DBValues(PosToRead)
                print(f"{conn.Name} Value: {current_val}, Index: {PosToRead}")
except KeyboardInterrupt:
    print("\nPress any key to close Dewesoft... ", end = "")
    input()

# close dewesoft
dw.Stop()
sys.stdout.flush()
dw = None
print("Dewesoft closed.")
sys.stdout.flush()
